Bug 1979702 (CVE-2021-32740)

Summary: CVE-2021-32740 rubygem-addressable: ReDoS in templates
Product: [Other] Security Response Reporter: Guilherme de Almeida Suckevicz <gsuckevi>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: medium Docs Contact:
Priority: medium    
Version: unspecifiedCC: aboyko, akarol, amackenz, amasferr, aos-bugs, bbuckingham, bcourt, bkearney, bmontgom, bnhassin, boliveir, btotty, chazlett, dbecker, dmetzger, drieden, ehelms, eparis, ewolinet, gmccullo, gtanzill, jburrell, jcantril, jhardy, jjoyce, jokerman, jschluet, jsherril, kaycoth, lhh, lpeer, lzap, mburns, mhulan, mkudlej, mmccune, mo, myarboro, nmoumoul, nstielau, obarenbo, orabin, pcreech, pdrozd, pjindal, pskopek, rchan, rjerrido, roliveri, sclewis, shawn.starr, simaishi, slinaber, smallamp, sokeeffe, sponnaga, sthorger, tdawson, tjochec, vondruch
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: addressable 2.8.0 Doc Type: If docs needed, set a value
Doc Text:
A resource-consumption vulnerability was found in rubygem addressable, where its URI template implementation could allow an attacker's crafted template to consume resources, resulting in a denial of service. The highest threat from this vulnerability is to system availability.
Story Points: ---
Clone Of: Environment:
Last Closed: 2021-11-01 01:49:01 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On: 1979704, 1982122, 1979703, 1980197, 1980283, 1980946    
Bug Blocks: 1979706, 1997390    

Description Guilherme de Almeida Suckevicz 2021-07-06 18:50:48 UTC
Addressable is an alternative implementation to the URI implementation that is part of Ruby's standard library. An uncontrolled resource consumption vulnerability exists after version 2.3.0 through version 2.7.0. Within the URI template implementation in Addressable, a maliciously crafted template may result in uncontrolled resource consumption, leading to denial of service when matched against a URI. In typical usage, templates would not normally be read from untrusted user input, but nonetheless, no previous security advisory for Addressable has cautioned against doing this. Users of the parsing capabilities in Addressable but not the URI template capabilities are unaffected. The vulnerability is patched in version 2.8.0. As a workaround, only create Template objects from trusted sources that have been validated not to produce catastrophic backtracking.

Reference:
https://github.com/sporkmonger/addressable/security/advisories/GHSA-jxhc-q857-3j6g

Comment 1 Guilherme de Almeida Suckevicz 2021-07-06 18:51:17 UTC
Created rubygem-addressable tracking bugs for this issue:

Affects: epel-7 [bug 1979704]
Affects: fedora-all [bug 1979703]

Comment 15 errata-xmlrpc 2021-11-16 14:08:20 UTC
This issue has been addressed in the following products:

  Red Hat Satellite 6.10 for RHEL 7

Via RHSA-2021:4702 https://access.redhat.com/errata/RHSA-2021:4702